#
#  Dict.pl: Frontend to dict.org.
#   Author: dms
#  Version: v0.6c (20000924).
#  Created: 19990914.
#

#package Dict;
use Net::Dict;

my $server	= "kurtwerks.com";	# need a specific host||ip.
my $port	= 2628;
my $proto	= getprotobyname('tcp');

###local $SIG{ALRM} = sub { die "alarm\n" };

sub Dict {
    my ($query) = @_;
    my $retval = "";

    my $dict = Net::Dict->new($server)
      or return "Somebody burned my dictionary: $!";
    for ($query) {
	s/^[\s\t]+//;
	s/[\s\t]+$//;
	s/[\s\t]+/ /;
    }

    my $num;
    if ($query =~ s/^(\d+)\s+//) {
	$num = $1;
    }

    # body.
    #push(@results, &Dict_Wordnet($socket,$query));
    #push(@results, &Dict_Foldoc($socket,$query));
    $dict->setDicts('wn', 'foldoc');
    $h = $dict->define($query);
    my @defs = @{$h};
    my $prefix = "\002$query\002: ";

    if(scalar @defs) {			# No spell check required
	$retval = "$prefix";
	foreach $i (@defs) {
	    ($db, $def) = @{$i};
	    print $def."\n";
	    $retval .= "$def ";
	}
    }
    else {				# Spell checking required.
	$retval = Speller($query,$dict);
	if ( !$retval ) {
	    $retval = "Could not find definition for \002$query\002";
	}
    }

    $retval =~ s/[\r\n]//g;
    $retval =~ s/\s{2,}/ /g;
    if ( length($retval) > (445*2) ) {	# Longer than two messages...
	$retval = "\002$query\002: Definition too long. See: http://dictionary.reference.com/search?q=$query";
    }
    return "$retval";
}

sub Speller {
    my ($squery,$dict) = @_;
    if ( !$dict ) {
	$dict = Net::Dict->new($server)
	  or return "Somebody burned my dictionary: $!";
	$dict->setDicts('wn', 'foldoc');
    }
    else { $isd = 1 }

    for ($squery) {
	s/^[\s\t]+//;
	s/[\s\t]+$//;
	s/[\s\t]+/ /;
    }

    my $num;
    if ($squery =~ s/^(\d+)\s+//) {
	$num = $1;
    }

    my @matches  = @{$dict->match($squery, 'exact')};
    if ( scalar @matches ) { return "\002$squery\002 is correct" }
    my @matches  = @{$dict->match($squery, 'lev')};
    my $retsp = "";
    if ( scalar @matches ) {
	$retsp = "\002$squery\002".($isd?" suggestions":"").": ";
	my $i = 0;
	foreach $match (@matches) {
	    my ($db, $word) = @{ $match };
	    $i++;
	    $retsp .= "$word ";
	    last if $i == 10;
	}
    }
    elsif ($isd) {
	return "";
    }
    else {
	return "Could not find any suggestions for \002$squery\002";
    }
    return $retsp;
}
# nandBot stuff
our @commands;
my @command = ();
my @command_sp = ();

# Dict command
$command[0]='^dict \+?(.+)$';		# RegExp Match
$command[1]='Dict($1)';			# Function call
push @commands,\@command;

# Spell command
$command_sp[0]='^spell \+?(.+)$';
$command_sp[1]='Speller($1)';
push @commands,\@command_sp;
# end nandBot stuff
1;
