#!/usr/bin/perl
#use LWP::UserAgent;
#use HTTP::Request;
use IO::Socket;

my %clouds = (
	      "CLR"=>"Clear","BKN"=>"Broken clouds","SCT"=>"Scattered clouds",
	      "FEW"=>"Few clouds","OVC"=>"Overcast",
	     );
my @phenon = (
#*                   NONE                         VICINITY                             LIGHT                      MODERATE                      HEAVY                      SHALLOW                      PATCHES                         PARTIAL                      THUNDERSTORM                    BLOWING                      SHOWERS                         DRIFTING                      FREEZING                      */
#*               *******************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************************/
["",                          "",                                  "",                        "",                           "",                        "",                          "",                             "",                          "",                             "",                          "",                             "",                           "",                          ], # NONE
["Drizzle",               "Drizzle in the vicinity",       "Light drizzle",       "Moderate drizzle",       "Heavy drizzle",       "Shallow drizzle",       "Patches of drizzle",       "Partial drizzle",       "Thunderstorm",             "Windy drizzle",         "Showers",                  "Drifting drizzle",       "Freezing drizzle"       ],	# DRIZZLE
["Rain ",                 "Rain in the vicinity" ,         "Light rain",          "Moderate rain",          "Heavy rain",          "Shallow rain",          "Patches of rain",          "Partial rainfall",      "Thunderstorm",             "Blowing rainfall",      "Rain showers",             "Drifting rain",          "Freezing rain"          ],	# RAIN
["Snow",                  "Snow in the vicinity" ,         "Light snow",          "Moderate snow",          "Heavy snow",          "Shallow snow",          "Patches of snow",          "Partial snowfali",      "Snowstorm",                "Blowing snowfall",      "Snow showers",             "Drifting snow",          "Freezing snow"          ],	# SNOW
["Snow grains",           "Snow grains in the vicinity" ,  "Light snow grains",   "Moderate snow grains",   "Heavy snow grains",   "Shallow snow grains",   "Patches of snow grains",   "Partial snow grains",   "Snowstorm",                "Blowing snow grains",   "Snow grain showers",       "Drifting snow grains",   "Freezing snow grains"   ],	# SNOW_GRAINS
["Ice crystals",          "Ice crystals in the vicinity" , "Few ice crystals",    "Moderate ice crystals",  "Heavy ice crystals",  "??",                        "Patches of ice crystals",  "Partial ice crystals",  "Ice crystal storm",        "Blowing ice crystals",  "Showers of ice crystals",  "Drifting ice crystals",  "Freezing ice crystals"  ], # ICE_CRYSTALS
["Ice pellets",           "Ice pellets in the vicinity" ,  "Few ice pellets",     "Moderate ice pellets",   "Heavy ice pellets",   "Shallow ice pellets",   "Patches of ice pellets",   "Partial ice pellets",   "Ice pellet storm",         "Blowing ice pellets",   "Showers of ice pellets",   "Drifting ice pellets",   "Freezing ice pellets"   ],	# ICE_PELLETS
["Hail",                  "Hail in the vicinity" ,         "Light hail",          "Moderate hail",          "Heavy hail",          "Shallow hail",          "Patches of hail",          "Partial hail",          "Hailstorm",                "Blowing hail",          "Hail showers",             "Drifting hail",          "Freezing hail"          ],	# HAIL
["Small hail",            "Small hail in the vicinity" ,   "Light hail",          "Moderate small hail",    "Heavy small hail",    "Shallow small hail",    "Patches of small hail",    "Partial small hail",    "Small hailstorm",          "Blowing small hail",    "Showers of small hail",    "Drifting small hail",    "Freezing small hail"    ],	# SMALL_HAIL
["Unknown precipitation", "Precipitation in the vicinity", "Light precipitation", "Moderate precipitation", "Heavy precipitation", "Shallow precipitation", "Patches of precipitation", "Partial precipitation", "Unknown thunderstorm",     "Blowing precipitation", "Showers, type unknown",    "Drifting precipitation", "Freezing precipitation" ],	# PRECIPITATION
["Mist",                  "Mist in the vicinity" ,         "Light mist",          "Moderate mist",          "Thick mist",          "Shallow mist",          "Patches of mist",          "Partial mist",          "??",                           "Mist with wind",        "??",                           "Drifting mist",          "Freezing mist"          ],	# MIST
["Fog",                   "Fog in the vicinity" ,          "Light fog",           "Moderate fog",           "Thick fog",           "Shallow fog",           "Patches of fog",           "Partial fog",           "??",                           "Fog with wind",         "??",                           "Drifting fog",           "Freezing fog"           ],	# FOG
["Smoke",                 "Smoke in the vicinity" ,        "Thin smoke",          "Moderate smoke",         "Thick smoke",         "Shallow smoke",         "Patches of smoke",         "Partial smoke",         "Smoke w/ thunders",        "Smoke with wind",       "??",                           "Drifting smoke",         "??"                         ],	# SMOKE
["Volcanic ash",          "Volcanic ash in the vicinity" , "??",                      "Moderate volcanic ash",  "Thick volcanic ash",  "Shallow volcanic ash",  "Patches of volcanic ash",  "Partial volcanic ash",  "Volcanic ash w/ thunders", "Blowing volcanic ash",  "Showers of volcanic ash ", "Drifting volcanic ash",  "Freezing volcanic ash"  ], # VOLCANIC_ASH
["Sand",                  "Sand in the vicinity" ,         "Light sand",          "Moderate sand",          "Heavy sand",          "??",                        "Patches of sand",          "Partial sand",          "??",                           "Blowing sand",          "",                             "Drifting sand",          "??"                         ],	# SAND
["Haze",                  "Haze in the vicinity" ,         "Light haze",          "Moderate haze",          "Thick haze",          "Shallow haze",          "Patches of haze",          "Partial haze",          "??",                           "Haze with wind",        "??",                           "Drifting haze",          "Freezing haze"          ],	# HAZE
["Sprays",                "Sprays in the vicinity" ,       "Light sprays",        "Moderate sprays",        "Heavy sprays",        "Shallow sprays",        "Patches of sprays",        "Partial sprays",        "??",                           "Blowing sprays",        "??",                           "Drifting sprays",        "Freezing sprays"        ],	# SPRAY
["Dust",                  "Dust in the vicinity" ,         "Light dust",          "Moderate dust",          "Heavy dust",          "??",                        "Patches of dust",          "Partial dust",          "??",                           "Blowing dust",          "??",                           "Drifting dust",          "??"                         ],	# DUST
["Squall",                "Squall in the vicinity" ,       "Light squall",        "Moderate squall",        "Heavy squall",        "??",                        "??",                           "Partial squall",        "Thunderous squall",        "Blowing squall",        "??",                           "Drifting squall",        "Freezing squall"        ], # SQUALL
["Sandstorm",             "Sandstorm in the vicinity" ,    "Light standstorm",    "Moderate sandstorm",     "Heavy sandstorm",     "Shallow sandstorm",     "??",                           "Partual sandstorm",     "Thunderous sandstorm",     "Blowing sandstorm",     "??",                           "Drifting sandstorm",     "Freezing sandstorm"     ],	# SANDSTORM
["Duststorm",             "Duststorm in the vicinity" ,    "Light duststorm",     "Moderate duststorm",     "Heavy duststorm",     "Shallow duststorm",     "??",                           "Partial duststorm",     "Thunderous duststorm",     "Blowing duststorm",     "??",                           "Drifting duststorm",     "Freezing duststorm"     ],	# DUSTSTORM
["Funnel cloud",          "Funnel cloud in the vicinity" , "Light funnel cloud",  "Moderate funnel cloud",  "Thick funnel cloud",  "Shallow funnel cloud",  "Patches of funnel clouds", "Partial funnel clouds", "??",                           "Funnel cloud w/ wind",  "??",                           "Drifting funnel cloud",  "??"                         ], # FUNNEL_CLOUD
["Tornado",               "Tornado in the vicinity" ,      "??",                      "Moderate tornado",       "Raging tornado",      "??",                        "??",                           "Partial tornado",       "Thunderous tornado",       "Tornado",               "??",                           "Drifting tornado",       "Freezing tornado"       ],	# TORNADO
["Dust whirls",           "Dust whirls in the vicinity" ,  "Light dust whirls",   "Moderate dust whirls",   "Heavy dust whirls",   "Shallow dust whirls",   "Patches of dust whirls",   "Partial dust whirls",   "??",                           "Blowing dust whirls",   "??",                           "Drifting dust whirls",   "??"                         ] # DUST_WHIRLS
);
"NONE VICINITY LIGHT MODERATE HEAVY SHALLOW PATCHES PARTIAL THUNDERSTORM BLOWING SHOWERS DRIFTING FREEZING ";
my %typenum = (
	       ""=>0,VC=>1,"-"=>2,MOD=>3,"+"=>4,MI=>5,BC=>6,PR=>7,TS=>8,BL=>9,SH=>10,DR=>11,FZ=>12,
	      );
my %phenum = (
	      DZ=>0,RA=>1,SN=>2,SG=>3,IC=>4,PE=>5,GR=>6,GS=>7,UP=>8,BR=>9,FG=>10,FU=>11,VA=>12,SA=>13,HZ=>14,PY=>15,DU=>16,SQ=>17,SS=>18,DS=>19,FC=>20,
	      "+FC"=>21,PO=>22,
	     );
sub weather {
    my $code = shift @_;
    my %out = ();
    ## DOWNLOAD
    my $url = sprintf("/cgi-bin/mgetmetar.pl?cccc=%s", $code);
    my $metar = metarhttp("weather.noaa.gov",$url);
    $metar =~ s/[\r\n]//gm;
    $metar =~ /<FONT face="courier"[^\>]+>(.+?)\<\/FONT\>/i;
    $wstr = $1;
    # print "$wstr\n";
    @witems = split ' ',$wstr;
    my ($quali,$pheni,$skyi);
    foreach (@witems) {
	last if $_ eq "RMK";
	if ( m/^(\d\d)(\d\d)(\d\d)Z$/ ) {
	    $out{timeday}=$1;$out{timehr}=$2;$out{timemin}=$3;
	}
	elsif ( m/^(\d\d\d|VRB)([0-9]?\d\d)((G)([0-9]?\d\d))?KT$/ ) {
	    my ($dir,$speed,$gust,$sdir)=-1;
	    my ($sdir,$sspd,$sgust,$gustp,$gusti) = ($1,$2,$3,$4,$5);
	    $dir = $sdir eq "VRB" ? -1 : $sdir;
	    $sdir = $dir;
	    $sdir = "Variable" if $dir == -1;
	    $speed = $sspd;
	    if ( $gustp =~ /^G/ ) {
		$gust = $gusti;
	    }
	    $sdir = "North" if ((349 <= $dir) && ($dir <= 11));#N
	    $sdir = "North-NorthEast" if ((12 <= $dir) && ($dir <= 33));#NNE
	    $sdir = "Northeast" if ((34 <= $dir) && ($dir <= 56));#NE
	    $sdir = "East-NorthEast" if ((57 <= $dir) && ($dir <= 78));#ENE
	    $sdir = "East" if ((79 <= $dir) && ($dir <= 101));#E
	    $sdir = "East-Southeast" if ((102 <= $dir) && ($dir <= 123));#ESE
	    $sdir = "Southeast" if ((124 <= $dir) && ($dir <= 146));#SE
	    $sdir = "South-Southeast" if ((147 <= $dir) && ($dir <= 168));#SSE
	    $sdir = "South" if ((169 <= $dir) && ($dir <= 191));#S
	    $sdir = "South-Southwest" if ((192 <= $dir) && ($dir <= 213));#SSW
	    $sdir = "Southwest" if ((214 <= $dir) && ($dir <= 236));#SW
	    $sdir = "West-Southwest" if ((247 <= $dir) && ($dir <= 258));#WSW
	    $sdir = "West" if ((259 <= $dir) && ($dir <= 281));#W
	    $sdir = "West-Northwest" if ((282 <= $dir) && ($dir <= 303));#WNW
	    $sdir = "Northwest" if ((304 <= $dir) && ($dir <= 326));#NW
	    $sdir = "North-Northwest" if ((327 <= $dir) && ($dir <= 348));#NNW
	    $out{windir_str}=$sdir;
	    $out{windir}=$dir;
	    $out{windspeed}=$speed;
	    $out{windgust}=$gust;
	}
	elsif ( m/^((\d?\d)|((M?)1\/([0-9]?[0-9])))SM$/ ) {
	    my ($all,$first,$second,$token)=($1,$2,$3,$4);
	    my ($val,$vis);
	    if ( $5 ) {
		$val = $5;
		$vis = ($token eq 'M') ?  0.001 : (1.0 / $val);
	    }
	    else {
		$vis = $all;
	    }
	    $out{vis}=$vis;
	}
	elsif ( m/^(CLR|BKN|SCT|FEW|OVC)(\d\d\d)?$/ ) {
	    my ($cloud) = $clouds{$1};
	    $out{cloudstr}=$cloud;
	    $out{cloud}=$1;
	    #print "CLOUD $cloud - ALTITUDE $2\n";# -Unused in gweather,here.
	}
	elsif ( m/^(M?)([0-9][0-9])\/(M?)([0-9][0-9])$/ ) {
	    my ($tt,$temp,$td,$dew) = ($1,$2,$3,$4);
	    $temp = (((($tt eq "M" ? -$temp+1 : $temp)) * 1.8) + 32.0);
	    $dew = (((($td eq "M" ? -$dew+1 : $dew)) * 1.8) + 32.0);
	    $out{temp}=$temp;
	    $out{dew}=$dew;
	    $out{humid}=metarhumidity($temp,$dew);
	}
	elsif ( m/^(A|Q)(\d{4})$/ ) {
	    my ($token,$number) = ($1,$2);
	    my $pres;
	    if ( $token eq "A" ) {
		$number =~ /^(\d\d)(\d\d)$/;
		$pres = $1 + ($2/100.0);
	    }
	    else {				# Token "Q"
		$pres = (($number) * 0.02963742);
	    }
	    $out{pres}=$pres;
	}
	elsif ( m/^(-|\\+)?(VC|MI|BC|PR|TS|BL|SH|DR|FZ)?(DZ|RA|SN|SG|IC|PE|GR|GS|UP|BR|FG|FU|VA|SA|HZ|PY|DU|SQ|SS|DS|PO|\\+?FC)$/ ) {
	    my ($token,$qual,$cond) = ($1,$2,$3);
	    my $quanity=0;
	    if ( $token ) {
		$quanity = $typenum{$token};
	    }
	    elsif ( $qual ) {
		$quanity = $typenum{$qual};
	    }
	    else {
		$quanity = $typenum{MOD};
	    }
	    $out{cond}=$phenum{$cond}+1;
	    $out{quanity}=$quanity;
	}
    }
    return %out;
}
sub weatherstr {
    my %w = weather(@ARGV[0]);
    print "Time: $w{timeday}th at $w{timehr}:$w{timemin} GMT\n";
    print "WIND $w{windir_str} ". ($w{windgust}?"Gusting at $w{windgust} ":"") ."at $w{windspeed} KT.\n";
    print "VIS $w{vis} Miles\n";
    print "CLOUD $w{cloud} $w{cloudstr}\n";
    print "TEMP $w{temp} DEWPOINT $w{dew} HUMIDITY $w{humid}%\n";
    print "PRES $w{pres} INCHES\n";
    print "COND $phenon[$w{cond}][$w{quanity}]\n";
}
#print weathernb(@ARGV),"\n";
sub weathernb {
    # Wait! For where should we find the weather?
    my $loc = shift @_;
    my ($name,$return);
    if ( $loc !~ /^[A-Za-z\d]{4}$/ ) {
	#Not a station name, map it through the city gizmo
	my @results = city($loc);
	if (scalar(@results) > 1) {
	    $return = "Multiple results for '$loc': ".join("; ",@results).".\n";
	}
	$results[0]=~ /^([^ ]+) (.+)$/;
	if ( $results[0] ) {
	    $loc = $1;
	    $name= $2;
	}
	return "Invalid station name: $loc" if $loc !~ /^[A-Za-z]{4}$/;
    }
    else {
	$name = (city($loc)||"$loc");
    }
    my %w = weather($loc);
    unless ($w{timeday}) {
	my $oldstation=$loc;
      	my @results = city($loc);
	if (scalar(@results) > 1) {
	    $return = "Multiple results for '$loc': ".join("; ",@results).".\n";
	}
	$results[0]=~ /^([^ ]+) (.+)$/;
	if ( $results[0] ) {
	    $loc = $1;
	    $name= $2;
	}
	%w = weather($loc);
	if ($loc eq $oldstation || !$w{timeday} ) {
	    return "I couldn't get hold of the weatherman (or the weather wasn't available for that location)";
	}
    }
    my $ts = "Report Generated on the $w{timeday}th at $w{timehr}:$w{timemin}"
      ."GMT for $name:";
    my $cond = "Conditions: $phenon[$w{cond}][$w{quanity}], " if $w{cond};
    my $temp = "Temperature: $w{temp}F, (".sprintf("%.1f",(($w{temp}) - 32.0) * 0.555556)."C), " if $w{temp};
    my $sky = "Skies: $w{cloudstr}, "if $w{cloudstr};

    my $pres = "Pressure: $w{pres} Inches (".sprintf("%.1f",(($w{pres}) * 25.4))."mm), ";
    my $vis = "Visibility: $w{vis}Mi (".sprintf("%.1f",(($w{vis}) * 1.609344))."Km), "
      if $w{vis};
    $return .= " $ts $cond$temp$sky"."$pres$vis";
    chop $return;chop $return;
    return $return;
}
#define TEMP_F_TO_C(f)  (((f) - 32.0) * 0.555556)
#define TEMP_C_TO_F(c)  (((c) * 1.8) + 32.0)
#define TEMP_UNIT_STR(units)  (((units) == UNITS_IMPERIAL) ? "\260F" : "\260C")

#define WINDSPEED_KNOTS_TO_KPH(knots)  ((knots) * 1.851965)
#define WINDSPEED_KPH_TO_KNOTS(kph)    ((kph) * 0.539967)
#define WINDSPEED_UNIT_STR(units) (((units) == UNITS_IMPERIAL) ? "knots" : "kph")

#define PRESSURE_INCH_TO_MM(inch)   ((inch) * 25.4)
#define PRESSURE_MM_TO_INCH(mm)     ((mm) * 0.03937)
#define PRESSURE_MBAR_TO_INCH(mbar) ((mbar) * 0.02963742)
#define PRESSURE_UNIT_STR(units) (((units) == UNITS_IMPERIAL) ? "inHg" : "mmHg")

#define VISIBILITY_SM_TO_KM(sm)  ((sm) * 1.609344)
#define VISIBILITY_KM_TO_SM(km)  ((km) * 0.621371)
#define VISIBILITY_UNIT_STR(units) (((units) == UNITS_IMPERIAL) ? "miles" : "kilometers")

sub metarpow {
    return exp($_[1]*log($_[0]))
}
sub metarhumidity {
    my ($temp,$dewp) = @_;
    $temp = ((($temp) - 32.0) * 0.555556);
    $dewp = ((($dewp) - 32.0) * 0.555556);

    $esat = 6.11 * metarpow(10.0, (7.5 * $temp) / (237.7 + $temp));
    $esurf = 6.11 * metarpow(10.0, (7.5 * $dewp) / (237.7 + $dewp));

    return sprintf("%.1f",(($esurf/$esat) * 100.0));
#    return -1;
}
sub metarhttp {
    my ($host,$page) = @_;
    $socket = IO::Socket::INET->new(PeerAddr => "$host",
				    PeerPort => 80,
				    Proto    => "tcp",
				    Type     => SOCK_STREAM)
      or return 0;
    print $socket "GET $page HTTP/1.0\r\n\r\n";
    while(<$socket>) {
	$_ =~ s/[\r\n]//g;
	last if $_ eq "";
    }
    my $msg = "";
    while(<$socket>) {
	$_ =~ s/[\r\n]//g;
	$msg .= $_;
    }
    return $msg;
}
sub icon {
    my $icon = '';
    if ($quali eq 'NONE' ) {
	break;
    }
    elsif ( $quali eq 'THUNDERSTORM' ) {
	$icon = 'TSTORM';
    }
    if ( $quali eq 'SHALLOW' ||
	 $quali eq 'PATCHES' ||
	 $quali eq 'PARTIAL' ||
	 $quali eq 'BLOWING' ||
	 $quali eq 'SHOWERS' ||
	 $quali eq 'DRIFTING'||
	 $quali eq 'FREEZING' ) {
    }
    elsif ($quali eq 'LIGHT' || $quali eq 'MODERATE' || $quali eq 'HEAVY' ) {
    }
    unless ( $icon ) {
	if ( $pheni eq 'DRIZZLE' || $pheni eq 'RAIN' || $pheni eq 'UNKNOWN_PRECIPITATION' ) {
	    if (($quali eq 'SHALLOW') ||
		($quali eq 'PATCHES') ||
		($quali eq 'PARTIAL')) {
		$icon = 'RAIN'
	    }
	    else {
		$icon = 'RAIN';
	    }
	}
	if ( $pheni eq 'SNOW' || $phenoni eq 'ICE_PELLETS' ) {
	    $icon = 'SNOW';
	}
	if ( $pheni eq 'HAIL' ||
	     $pheni eq 'SMALL_HAIL') {
	    $icon = 'RAIN';
	}
	if ( $pheni eq 'TORNADO' ||
	     $pheni eq 'SQUALL' ) {
	    $icon = 'TSTORM';
	}
	if ($pheni eq 'MIST'||
	    $pheni eq 'FOG' ||
	    $pheni eq 'SMOKE'||
	    $pheni eq 'VOLCANIC_ASH' ||
	    $pheni eq 'SAND'||
	    $pheni eq 'HAZE'||
	    $pheni eq 'SPRAY'||
	    $pheni eq 'DUST'||
	    $pheni eq 'SANDSTORM'||
	    $pheni eq 'DUSTSTORM'||
	    $pheni eq 'FUNNEL_CLOUD'||
	    $pheni eq 'DUST_WHIRLS' ) {
	    $icon = 'FOG';
	}
    }
    else {
	if ( $skyi eq 'CLEAR' ) {
	    $icon = 'SUN';
	}
	if ( $skyi eq 'BROKEN' ||
	     $skyi eq 'SCATTERED' ||
	     $skyi eq 'FEW' ) {
	    $icon = 'SUNCLOUD';
	}
	if ( $skyi eq 'OVERCAST' ) {
	    $icon = 'CLOUD';
	}
    }
    return $icon;
}
sub city {
    my $lookfor = shift @_;
    $lookfor =~ /^([^\,]+)(, (.+))?$/;
    $lookfor = $1;
    my $looktop = $3;
    my @found = ();
    open STATIONS, "lib/weatherstations.txt" or return "City->Station_file_missing, EGLC";
    my $section;
    while (<STATIONS>) {
	$_ =~ s/[\r\n]//g;
	if ( $_ =~ /^\[(\w\w)_(\w\w)\]$/i ) {
	    #print "\n'$2' '$looktop'";
	    my $stwo = $2;
	    next if ( ($looktop =~ /^\w\w$/) && (uc($looktop) ne uc($stwo)));
	    my $ignore =0;
	    while (<STATIONS>) {
		$_ =~ s/[\r\n]//g;
		if ( $_ =~ /^name=(.+)$/) {
		    #print " $1";
		    $section = $1;
		    if ( $looktop !~ /^\w\w$/ ) {
			$ignore++
			  if ( ($looktop) && (uc($looktop) ne uc($section)));
			#print " ===================" if !$ignore;
		    }
		    #print "Section: $1\n";
		}
		elsif ($_ =~ /^loc\d+\w?\=(([^ ]+(\\\\ )?)+) ([A-Z\d]{4})/ && !$ignore) {
		    my ($name,$station) = ($1,$4);
		    $name =~ s/\\\\//g;
		    #print "$name = $station\n";
		    if ( $name =~ /^$lookfor/i ) {
			push @found,"$station $name, $section";
		    }
		    if ( $station eq $lookfor ) {
			return "$name, $section";
		    }
		}
		else {
		    last;
		}
	    }
	}
    }
    return @found;
}

our @commands;
my @command = ();
$command[0]='^weather (for )?(.+)$';	# RegExp Match
$command[1]='weathernb($2)';		# Function call
push @commands,\@command;

1;
