use IO::Socket;

sub arinwhois {
    my ($ip) = @_;
    $socket = IO::Socket::INET->new(PeerAddr => "ws.arin.net",
				    PeerPort => 80,
				    Proto    => "tcp",
				    Type     => SOCK_STREAM)
      or return 0;
    print $socket "GET http://ws.arin.net/cgi-bin/whois.pl?queryinput=$ip HTTP/1.0\r\nHost: ws.arin.net\r\n\r\n";
    while(<$socket>) {
	$_ =~ s/[\r\n]//g;
	last if $_ =~ /\<pre\>/i;
    }
    my $msg = "";
    my $ra = "\002$ip\002: ";
    my $r = "";
    while(<$socket>) {
	$_ =~ s/[\r\n]//g;
	s/^\s*//g;
	#print STDERR ">$_\n";
	if ( m/^\# ARIN WHOIS database, last updated / ) {
	    last;
	}
	elsif ( m/^OrgName:\s+(.+)$/i ) {
	    $r .= $1." ";
	}
	elsif ( m/^NetRange:\s+<[^>]+>(\d+\.\d+\.\d+\.\d+)<\/a>\s*-\s*<[^>]+>(\d+\.\d+\.\d+\.\d+)<\/a>/i ) {
	    $r .= "$1 - $2";
	}
	elsif ( m/^No match found for/i ) {
	    $r .= "No Match";
	    last;
	}
	elsif ( m/^([^\:]+) \(<A/ ) {
	    $r .= "$1 ";
	}
	elsif ( m/^<[^>]+>(\d+\.\d+\.\d+\.\d+)<\/a>\s*-\s*<[^>]+>(\d+\.\d+\.\d+\.\d+)/i ) {
	    $r .= "$1 - $2";
	    last;
	}
    }
    $r = "No Match" unless $r;
    $r = "$ra$r";
    return $r;
}

our @commands;
my @command = ();

# ARIN Whois
$command[0]='^whois (\d+\.\d+\.\d+\.\d+)$'; # RegExp Match
$command[1]='arinwhois($1)'; # Function call
push @commands,\@command;
